//////////////////////////////////////////////////////////////////
// MAIN
//
//
//     FILE : client.cpp
//  CREATED : 19.07.2000
// (c) Borisov E.S. , Kiev UA
//
//       OS : QNX 4.25
// COMPILER : Watcom C/C++ 10.6
////////////////////////////////////////////////////////

#include <iostream.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include <time.h>

#include "manager.h"

const int MAX_FILE=50;

char crfile[MAX_FILE]="";
char conffile[MAX_FILE]="./crypt.hosts";
int maxlen=0;

//============================================================
//
int argparse(int argc,char *argv[])
{
    int eflg=0;
    int c =0;
    /////////////////////////////////////////////////
    // arg parse
	while( ( c = getopt( argc, argv, "k:**c:**f:**" ) ) != -1 ) 
	{
		switch( c ) 
		{
			case 'c': 
				sprintf(conffile,optarg);			
				break;

			case 'f': 
				sprintf(crfile,optarg);			
				break;

			case 'k': 
				maxlen=atoi(optarg);			
				break;
	

			default:
				eflg=1;
 		}
	}
	
	if( (strlen(crfile)<1)||(strlen(conffile)<1)||eflg||(maxlen<1))
	{
       cout << "(c) Borisov E.S. Kiev UA 2000\n"
            << "usage: "<<argv[0]<<" -f file -k length [  -c file ]\n\n"
            << "  -f <cryptogram file>\n"
            << "  -k <max key length>\n" 
            << "  -c <config file> (def.\".\\crypt.hosts\") \n\n";
 	   return 1;
	}
	//
	/////////////////////////////////////////

	return 0;
}


//=====================================
//
void main(int argc,char *argv[])
{
   CManager obj;
   clock_t start_time, end_time;
   
   cout <<"\n  -=* crypt client v.2 *=-\n\n";
   
   if(argparse(argc,argv))return;
   start_time = clock();
   if(obj.run(crfile,conffile,maxlen))return;
   end_time = clock();
   cout<<"-------------------------\n"
       <<"client : time = "
       <<(end_time - start_time) / CLOCKS_PER_SEC <<" sec.\n";
   
   cout<<"RESULT : key = '"<<obj.getmaxkey()<<"'\n";
}
