//////////////////////////////////////////////////////////////////
// cryptographer client
//
//     FILE : cryptclient.cpp
//  CREATED : 19.07.2000
// (C) Borisov E.S. Kiev UA
//
//       OS : QNX 4.25
// COMPILER : Watcom C/C++ 10.6
//
/////////////////////////////////////////////////////////////////
#include <iostream.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <errno.h>

#include "../server/netparams.h"
#include "cryptclient.h"

//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
CCryptclient::CCryptclient():m_cryptogramsize(0)
{ 
   sprintf(m_cryptogram,"");
}

//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
CCryptclient::~CCryptclient(){}

//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
int CCryptclient::shutdown_server()
{
   int cm=NET_MSG_SHUTDOWN;

   if(send(&cm,sizeof(cm)))return 0;
   return 1;
}

//=========================================================
// FUNCTION : int load_cryptogram(...) 
// PURPOSE  : 
//
int CCryptclient::load_cryptogram(char* szdatafile) 
{
    int fd=-1;
    //////////////////////////////////////////
    // open file
    if( (fd = open( szdatafile, 
    	            O_RDONLY,
    	            S_IRUSR | S_IWUSR) )==-1 )
    {
        cerr<<"client : open '"<<szdatafile<<"' - "<<strerror(errno)<<endl;
        return 2;
    }
    //
    //////////////////////////////////////////
    
    /////////////////////////////////////////////////
    // read in buffer
    if((m_cryptogramsize=read(fd, m_cryptogram,sizeof(m_cryptogram)))<1 )
    {
         cerr<<"client : read '"<<szdatafile<<"' - "<<strerror(errno)<<endl;
         close(fd);
         return 3;
    }
    //
    /////////////////////////////////////////////////
    close(fd);

    return 0;
}


//=========================================================
// FUNCTION : int send_work(...)
// PURPOSE  : 
//
int CCryptclient::send_work(char start,char stop,int maxlen)
{
   int size=0;
   int cm=NET_MSG_WORK;

   if(!send(&cm,sizeof(cm)))return 1;
   
   ///////////////////////////
   // SEND text
   if(!send(&m_cryptogramsize,sizeof(m_cryptogramsize)))return 1;
   if(!send(m_cryptogram,m_cryptogramsize))return 1;
   //
   ///////////////////////////

   ///////////////////////////
   // SEND  key
   if(!send(&start,sizeof(start)))return 1;
   if(!send(&stop,sizeof(stop)))return 1;
   if(!send(&maxlen,sizeof(maxlen)))return 1;
   //
   ///////////////////////////
   return 0;
}

//=========================================================
// FUNCTION : int receive_result(...)
// PURPOSE  : 
//
int CCryptclient::receive_result(char* szkey,int* pwords)
{
   int size=0;
   int cm=4;

   if(!send(&cm,sizeof(cm)))return 2;
   if(!recv(&size,sizeof(size)))return 3;

   if(!size) return -1;
   
   if(!recv(szkey,size))return 4;
   if(!recv(pwords,sizeof(int)))return 5;
   
   return 0;
}
  
