//////////////////////////////////////////////////////////////////
// multiserver cryptoclient
//
//     FILE : manager.cpp
//  CREATED : 18.07.2000
// (C) Borisov E.S. Kiev UA
//
//       OS : QNX 4.25
// COMPILER : Watcom C/C++ 10.6
//
/////////////////////////////////////////////////////////////////
#include <iostream.h>
#include <stdio.h>

#include "manager.h"

//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
CManager::CManager():m_words(0),m_start(0),m_stop(0),m_step(0)
{
    sprintf(m_maxkey,"");
}

//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
CManager::~CManager(){}

//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
int CManager::run(char* crfile,char* conffile,int keysize)
{
   m_maxlen=keysize;
   if(m_config.read(conffile))return 1;
   m_config.print();
   if(load_cryptogram(crfile))return 2;
   if(load_servers())return 3;
   if(take_results())return 4;;

   return 0;
}

//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
char*  CManager::getmaxkey()
{
   return m_maxkey;
}

//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
int  CManager::getintv()
{
    m_start=m_stop+1;
    if(m_start>LAST)return 1;
    m_stop=m_stop+m_step;
    if(m_stop>LAST)m_stop=LAST;
    
    return 0;

}

//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
int CManager::load_servers()
{
    char host[MAX_HOSTNAME]="";
    int  port=0;

    m_step=(LAST-FIRST)/m_config.get_srv_quantity();
    m_start=FIRST;
    m_stop=m_start+m_step;

    for(;;)
    {
       if(m_config.getfreesrv(host,&port))break;
       if(connect(host,port))return 1;
       send_work(m_start,m_stop,m_maxlen);
       disconnect();  
       if(getintv())break;
     }

     return 0;
}

//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
int CManager::take_results()
{
    char szkey[MAX_KEY]="";
    int words=0;
    char host[MAX_HOSTNAME]="";
    int  port=0;;
    
    for(;;)
    {
       if(m_config.getbusysrv(host,&port))break;
       if(connect(host,port))return 1;
       if(receive_result(szkey,&words))return 1;
       disconnect();  
       if(m_words<words)
       {
          sprintf(m_maxkey,szkey);
          m_words=words;
       }
     }
     

     return 0;
}
