//////////////////////////////////////////////////////////////////
//  net client
//
//     FILE : tcpclient.cpp
//  CREATED : 08.07.2000
// (C) Borisov E.S. Kiev UA
//
//       OS : QNX 4.25
// COMPILER : Watcom C/C++ 10.6
//
/////////////////////////////////////////////////////////////////
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <iostream.h>
#include <errno.h>
#include <unistd.h>

#include "tcpclient.h"

//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
CTcpClient::CTcpClient():m_sock(-1){}

//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
CTcpClient::~CTcpClient(){ disconnect(); }

//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
int CTcpClient::connect(char* serv,int port)
{
	struct sockaddr_in server;
	struct hostent *hp;

	///////////////////////////////////////////////////////////
	// 
    if( !(strlen(serv)&&(port>0)) )
    {
		cerr << "client : bad server name or port number\n";
		return 1;
    }
    //
	///////////////////////////////////////////////////////////
    
    if(m_sock>-1)disconnect();
    
    cout << "client : create connection ("
         <<serv
         <<" : "
         <<port
         <<") ... ";

	///////////////////////////////////////////////////////////
	// Create socket 
	if ((m_sock = ::socket(AF_INET, SOCK_STREAM, 0))< 0) 
	{
		cerr << "socket - "<<strerror(errno)<<endl;
        return 1;
	}
	//
	//////////////////////////////////////////////
	
	server.sin_family = AF_INET;
	if((hp = ::gethostbyname(serv)) == 0) 
	{
		herror( "gethostbyname - " );
	    return 1;
	}
	memcpy(&server.sin_addr, hp->h_addr, hp->h_length);
	server.sin_port = htons(port);

	//////////////////////////////////////////////////
	// Connect socket   
	if(::connect( m_sock,
	              (struct sockaddr *)&server,
	              sizeof(server)) < 0) 
	{
		cerr << "connect - "<<strerror(errno)<<endl;
	    return 2;
	}
	//
	///////////////////////////////////////////
    cout <<"ok\n";

    return 0;
}

//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
int CTcpClient::disconnect()
{
    int res=0;
    
    cout << "client : disconnect .... ";
	
	if(m_sock>-1)
	{
		if( ::shutdown(m_sock,2))
		{
		   cerr << "shutdown - "<<strerror(errno)<<endl;
		   res++;  
		}
		if( ::close(m_sock))
		{
		   cerr << "close - "<<strerror(errno)<<endl;
		   res++;
		}
	}	
	
	if(!res)cout << "ok\n";
	
	m_sock =-1;
	
	return res;
}


//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
int CTcpClient::recv(void* buffer,int size)
{
	int rd=-1;
	
	if(m_sock<0)return 1;
	
	if((rd=::recv(m_sock,buffer,size,0))<1)
	{
  	    cerr <<"client : recv .......... "<<strerror(errno)<<endl;
	}
	return rd;
}

//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
int CTcpClient::send(void* buffer,int size)
{
   int wr=-1;
   
   if(m_sock<0)return 1;
   if((wr= ::send(m_sock,buffer,size,0)) <1)
   {
	    cerr <<"client : send ... "<< strerror(errno)<<endl;
   }
   return wr;
}
