//////////////////////////////////////////////////////////////////
//  Data coder
//
//     FILE : crypter.cpp
//  CREATED : 20.07.2000
// (C) Borisov E.S. Kiev UA
//
//       OS : QNX 4.25
// COMPILER : Watcom C/C++ 10.6
//
/////////////////////////////////////////////////////////////////
#include <iostream.h>
#include <strstream.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include "crypter.h"

//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
CCrypter::CCrypter():m_pKey(0),m_inFd(-1),m_outFd(-1)
{
}

//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
int CCrypter::open(char* szInFile,char* szOutFile)
{
    //////////////////////////////////////////
    // open files
    if( (m_inFd = ::open( szInFile, 
    	                O_RDONLY,
    	                S_IRUSR | S_IWUSR) )==-1 )
    {
//        cerr<<"open "<<szInFile<<" : "<<strerror(errno)<<endl;
        return 1;
    }
    
    if( (m_outFd = ::open( szOutFile, 
                         O_WRONLY | O_CREAT | O_TRUNC,
    	                 S_IRUSR | S_IWUSR) )==-1 )
    {
//        cerr<<"open "<<szOutFile<<" : "<<strerror(errno)<<endl;
   	    return 2;
    }

    //
    //////////////////////////////////////////////////
    return 0;
}

//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
CCrypter::~CCrypter()
{
   close();
}

//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
void CCrypter::close()
{
   if(m_inFd) ::close(m_inFd);
   if(m_outFd) ::close(m_outFd);
   if(m_pKey) delete [] m_pKey;
   m_outFd=-1;
   m_inFd=-1;
   m_pKey=0;
}


//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
int CCrypter::mkKey(char* pszPswd,int isize)
{
   ////////////////////////////////
   // delete old key
   if(m_pKey!=0)
   {
      delete [] m_pKey;
      m_pKey=0;
   }
   //
   ////////////////////////////////
   
   if((m_pKey = new char[isize])==0)   
   {
//      cerr<<"new : "<<strerror(errno)<<endl;
      return 1;
   }   
   ostrstream(m_pKey,sizeof(m_pKey)*isize)<<pszPswd;
   return 0;
   
}

//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
int CCrypter::go(char* infl,char* outfl,char* key,int sizekey)
{
    if(open(infl,outfl))return 1;
    if(mkKey(key,sizekey))return 1;
    if(go())return 1;

    return 0;
}

//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
int CCrypter::go()
{
   int ikey_size;
   int ird;
   int i;
   int res=0;

   ikey_size=strlen(m_pKey);

   /////////////////////////////////////////////////
   // create buffer
   char* pszBuf = new char[ikey_size];
   if(pszBuf==0)
   {
//	  cerr <<"new : "<<strerror(errno)<<endl;
	  return 1;
   }
   //
   /////////////////////////////////////////////////
   
   while(!eof(m_inFd))
   {
      /////////////////////////////////////////////////
      // read in buffer
      ird=read(m_inFd, pszBuf,ikey_size);
      if(ird<1)
      {
//         cerr<<"read : "<<strerror(errno)<<endl;
         res++;
         break;
      }
      //
      /////////////////////////////////////////////////
      
      /////////////////////////////////////////////////
      // coding
      for(i=0;i<ird;i++)   
      {
          pszBuf[i] = pszBuf[i]^m_pKey[i];  
      }
      //
      ///////////////////////////////////////////////////
   
      /////////////////////////////////////////////////
      // write on out
      if( write(m_outFd,pszBuf,ird)!=ird )
      {
//         cerr<<"write : "<<strerror(errno)<<endl;
         res++;
         break;
      }
      //
      /////////////////////////////////////////////////
   }

   if(pszBuf!=0) delete [] pszBuf;

   return res;
}
