//////////////////////////////////////////////////////////////////
//  config file class
//
//     FILE : config.cpp
//  CREATED : 18.07.2000
// (C) Borisov E.S. Kiev UA
//
//       OS : QNX 4.25
// COMPILER : Watcom C/C++ 10.6
//
/////////////////////////////////////////////////////////////////
#include <iostream.h>
#include <errno.h>
#include <stdio.h>
#include "config.h"

//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
CConfig::CConfig():m_srvhead(0){}

//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
CConfig::~CConfig(){ del_srv(); }

//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
int CConfig::read(char* szfile)
{
   int res=0;
   int i=0;
   
   if( open(szfile) )return 1;
   for(i=0;;i++)
   {
      if(res=getserver())break;
      add_srv();
   }
   close();

   if( (i>0) && (res<0) ) return 0;
   
   return 2;
}


//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
int CConfig::add_srv()
{
   srvstack_t* pbuf= new srvstack_t;
   
   if(pbuf==0)
   {
      cerr<<"config  new - "<<strerror(errno)<<endl;
      return 1;
   }
   sprintf(pbuf->name,"%s",m_host);
   pbuf->port=m_port;
   pbuf->status=SRV_FREE;

   pbuf->link=m_srvhead;
   m_srvhead=pbuf;  
   
   return 0;
} 

//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
int CConfig::getfreesrv(char* name,int* port)
{
   srvstack_t* pbuf=0;
   
   if(!(pbuf=m_srvhead))return 1;
   do
   {
      if(pbuf->status==SRV_FREE)
      {
         sprintf(name,pbuf->name);
         *port=pbuf->port;
         pbuf->status=SRV_BUSY;
         return 0;
      }   
   }while(pbuf=pbuf->link);

   return 1;
}

//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
int CConfig::getbusysrv(char* name,int* port)
{
   srvstack_t* pbuf=0;

   if(!(pbuf=m_srvhead))return 1;
   do
   {
      if(pbuf->status==SRV_BUSY)
      {
         sprintf(name,pbuf->name);
         *port=pbuf->port;
         pbuf->status=SRV_FREE;
         return 0;
      }
   }while(pbuf=pbuf->link);

   return 1;
}

//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
int CConfig::get_srv_quantity() const
{
   srvstack_t* pbuf=0;
   int i=1;

   if(!(pbuf=m_srvhead))return 0;
   
   for(i=1;pbuf=pbuf->link;i++);

   return i;

}

//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
void CConfig::del_srv()
{
   srvstack_t* pbuf;

   while(pbuf=m_srvhead) 
   {
     m_srvhead=m_srvhead->link;
     delete pbuf;
   }
} 

//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
void CConfig::print()
{
   srvstack_t* pbuf;

   cout<<"--------------\n";
   
   if(!(pbuf=m_srvhead))return;
   do
   {
      cout<<pbuf->name<<" : "<<pbuf->port<<endl;
   }while(pbuf=pbuf->link);
   cout<<"----------------\n";
} 

