//////////////////////////////////////////////////////////////////
//  lexical analyser for config file
//
//     FILE : lexan.cpp
//  CREATED : 17.07.2000
// (C) Borisov E.S. Kiev UA
//
//       OS : QNX 4.25
// COMPILER : Watcom C/C++ 10.6
//
/////////////////////////////////////////////////////////////////
#include <iostream.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <errno.h>
#include <ctype.h>

#include "lexan.h"

//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
CLexan::CLexan():m_cursymb('\n'),m_fd(-1)
{    
     m_curlex.code   = ILLEGAL;    
     m_curlex.ivalue = 0;
     m_curlex.line   = 0;
}

//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
CLexan::~CLexan(){ close(); }

//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
lexeme_t  CLexan::getcurlex() const
{
  return m_curlex;
}

//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
int CLexan::ignore_comments()
{
	while( isspace(m_cursymb) || (m_cursymb =='#'))
	{
	  ////////////////////////////////////////
	  // comments
	  if(m_cursymb =='#')
	  {
	      while( (m_cursymb!='\n')&&(m_cursymb != CEOF) )
          if(getsymb())return 1;
	      m_curlex.line++;
          if(getsymb())return 1;
	  }
	  //
	  ///////////////////////////////////
	  
	  /////////////////////////////////////
	  // space
	  while(isspace(m_cursymb))
	  {
	     if(m_cursymb =='\n')m_curlex.line++;
         if(getsymb())return 1;
	  }
	  //
	  ///////////////////////////////////
	}
   return 0;
}


//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
int CLexan::getlex()
{

    if(ignore_comments())return 1;
	///////////////////////////////////
	// check EOF 
	if(m_cursymb == CEOF)
	{
		m_curlex.code = EOF;	
		return 0;
	}
	//
	///////////////////////////////////
		
	///////////////////////////////////
	// check lexemes 
	if(isdigit(m_cursymb))
	{
		if( getnumber() )return 1;
	}
	else
	{
	   if(isalpha(m_cursymb))
	   {
	      if( getword() )return 1;
	   }
	   else
	   {
	      if(strchr(TERMSYMB,m_cursymb))
	      {
              m_curlex.code = m_cursymb;
              if( getsymb() )return 1;
          } 
	      else
	      {
	         if(m_cursymb == CEOF)
	         {
	            m_curlex.code = EOF;
	         }
	         else
	         {
	            cerr<<"illegal character '"<<m_cursymb<<"'\n";
	            
	            m_curlex.code = ILLEGAL;  
	            return -1;
	         }
	      }
	   }
	}
	//
	///////////////////////////////////

	return 0;
} 

//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
int CLexan::getword()
{
	char wordbuf[MAX_HOSTNAME]="";

	while( !(strchr(TERMSYMB,m_cursymb)||(m_cursymb==CEOF)) )
	{
		sprintf(wordbuf,"%s%c",wordbuf,m_cursymb);
		if(getsymb())return 1;
	}

    m_curlex.code = WORDL;
    sprintf(m_curlex.szvalue,wordbuf);
    
    return 0;
}


//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
int CLexan::getnumber()
{
    for(m_curlex.ivalue = 0;isdigit(m_cursymb);)
    {
    	m_curlex.ivalue =  m_curlex.ivalue*10 + m_cursymb -'0';
    	if(getsymb())return 1;
    }
    m_curlex.code = NUMBL;
    return 0;
}


//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
int CLexan::getsymb()
{
    if(eof(m_fd))
    {
    	m_cursymb = CEOF;
    	return 0;
    }
    
    if( read(m_fd, &m_cursymb,sizeof(m_cursymb)) < 1)
    {
        cerr<<"read file - "<<strerror(errno)<<endl;
        return 1;
    }
   	return 0;
}

//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
int CLexan::open(char*  szfilecfg)
{
    if( (m_fd = ::open( szfilecfg, 
    	         O_RDONLY,
    	         S_IRUSR | S_IWUSR) )==-1 )
    {
        cerr<<"open '"<<szfilecfg<<"' - "<<strerror(errno)<<endl;
        return 1;
    }
    return 0;
}

//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
int CLexan::close()
{
    int res=0;
    
    if(m_fd<0)return 0;

    if(::close(m_fd))
    {
        cerr<<"close file - "<<strerror(errno)<<endl;
        res++;
    }
  
    m_fd = -1;    
    
    return res;
}

