//////////////////////////////////////////////////////////////////
//  lexical analyser for config file
//
//     FILE : lexan.h
//  CREATED : 17.07.2000
// (C) Borisov E.S. Kiev UA
//
//       OS : QNX 4.25
// COMPILER : Watcom C/C++ 10.6
//
/////////////////////////////////////////////////////////////////

#include "../server/netparams.h"

#ifndef _LEXAN_H_
#define _LEXAN_H_


const char TERMSYMB[]= " \n\t:#.";
const char CEOF = -1;


typedef enum
{
   NUMBL =  257,
   WORDL,   
   ILLEGAL  
}lexcode_t;


typedef struct
{
   int        code;
   union
   {  
      int        ivalue;
      char       szvalue[MAX_HOSTNAME];
   };
   long       line; 
}lexeme_t;


class CLexan
{
  public:
    CLexan();
    ~CLexan();
    int  open(char*  szfilecfg);
    int  close();
    int  getlex();

    lexeme_t  getcurlex() const;

  protected:
    int getsymb();
    int getnumber();
    int getword();
    int ignore_comments();
    
    lexeme_t    m_curlex;    
    char        m_cursymb;
    int         m_fd;

};

#endif