//////////////////////////////////////////////////////////////////
//  syntax analyser
//
//     FILE : syntan.cpp
//  CREATED : 18.07.2000
// (C) Borisov E.S. Kiev UA
//
//       OS : QNX 4.25
// COMPILER : Watcom C/C++ 10.6
//
/////////////////////////////////////////////////////////////////
#include <iostream.h>
#include <stdio.h>

#include "syntan.h"

//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
CSyntan::CSyntan():m_port(0)
{
    sprintf(m_host,"");
}

//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
CSyntan::~CSyntan(){}

//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
int CSyntan::parse_config(char* szfile)
{
      
   if( open(szfile) )return 1;
   for(;;)
   {
      if(getserver())break;
      cout<<"name = "<<m_host<<" port = "<<m_port<<endl;
   }
   close();

   return 0;
}

//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
int CSyntan::exam(int l)
{
   if(m_curlex.code!=l)
   {
        cerr<<"config - line "<<m_curlex.line<<" syntax error\n";
        return 1;
   }
   return 0;
}

//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
int CSyntan::getserver()
{
   if(getlex())return 1;
   if(m_curlex.code == EOF) return -1;

   if(gethostname())return 2;
   if(getlex())return 3;
   if(exam(':'))return 4;
   if(getlex())return 5;
   if(exam(NUMBL))return 6;

   m_port = m_curlex.ivalue;

   return 0;
}

//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
int CSyntan::gethostname()
{
   if(m_curlex.code == WORDL)
   {
       sprintf(m_host,m_curlex.szvalue);
       return 0;
   }
   else
      if(getIPaddress())return 3;
      else return 0;   

   return 4;      
}

//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
int CSyntan::getIPaddress()
{
   char szbuf[MAX_HOSTNAME]="";

   //////////////////////////////////
   // 1
   if(exam(NUMBL))return 1;       
   sprintf(szbuf,"%s%d",szbuf,m_curlex.ivalue);
   if(getlex())return 2;
   if(exam('.'))return 3;
   sprintf(szbuf,"%s.",szbuf);
   //
   //////////////////////////////////

   if(getlex())return 4;

   //////////////////////////////////
   // 2
   if(exam(NUMBL))return 5;       
   sprintf(szbuf,"%s%d",szbuf,m_curlex.ivalue);
   if(getlex())return 6;
   if(exam('.'))return 7;
   sprintf(szbuf,"%s.",szbuf);
   //
   //////////////////////////////////

   if(getlex())return 8;

   //////////////////////////////////
   // 3
   if(exam(NUMBL))return 9;       
   sprintf(szbuf,"%s%d",szbuf,m_curlex.ivalue);
   if(getlex())return 10;
   if(exam('.'))return 11;
   sprintf(szbuf,"%s.",szbuf);
   //
   //////////////////////////////////

   if(getlex())return 12;

   //////////////////////////////////
   // 4
   if(exam(NUMBL))return 13;       
   sprintf(m_host,"%s%d",szbuf,m_curlex.ivalue);
   //
   //////////////////////////////////

   return 0;
}