//////////////////////////////////////////////////////////////////
//  Data coder
//
//     FILE : coder.cpp
//  CREATED : 06.07.2000
// (C) Borisov E.S. Kiev UA
//
//       OS : QNX 4.25
// COMPILER : Watcom C/C++ 10.6
//
/////////////////////////////////////////////////////////////////
#include <iostream.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <errno.h>

#include "coder.h"

//=========================================================
// FUNCTION : CCoder()
// PURPOSE :
//
CCoder::CCoder():m_cryptogramsize(0),m_keysize(0)
{
    sprintf(m_cryptogram,"");
    sprintf(m_key,"");
}

//=========================================================
// FUNCTION : ~CCoder()
// PURPOSE :
// 
CCoder::~CCoder(){}

//=========================================================
// FUNCTION : set_key(...)
// PURPOSE  : set keyword for crypt
//
void CCoder::set_key(char* key,int size)
{
   m_keysize=min(size,MAX_KEY);
   memcpy(m_key,key,m_keysize);
}

//=========================================================
// FUNCTION : crypt()
// PURPOSE  : 
//
void CCoder::crypt()
{
   int i=0;
   int j=0;
    
   for(i=0;i<m_cryptogramsize;i++)   
   {
      m_text[i] = m_cryptogram[i]^m_key[j];  
      if( (++j)>(m_keysize-2))j=0;
   }
   m_textsize=m_cryptogramsize;
}
//=========================================================
// FUNCTION : void set_cryptogram(...) 
// PURPOSE  : 
//
void  CCoder::set_cryptogram(char* buf,int size)
{
   m_cryptogramsize=min(size,MAX_BUF);
   memcpy(m_cryptogram,buf,m_cryptogramsize);
} 

//=========================================================
// FUNCTION : int load_cryptogram(...) 
// PURPOSE  : 
//
int CCoder::load_cryptogram(char* szdatafile) 
{
    int fd=-1;
    //////////////////////////////////////////
    // open file
    if( (fd = open( szdatafile, 
    	            O_RDONLY,
    	            S_IRUSR | S_IWUSR) )==-1 )
    {
        cerr<<"coder open "<<szdatafile<<" - "<<strerror(errno)<<endl;
        return 2;
    }
    //
    //////////////////////////////////////////
    
    /////////////////////////////////////////////////
    // read in buffer
    if((m_cryptogramsize=read(fd, m_cryptogram,sizeof(m_cryptogram)))<1 )
    {
         cerr<<"coder read - "<<strerror(errno)<<endl;
         close(fd);
         return 3;
    }
    //
    /////////////////////////////////////////////////
    close(fd);
    
    set_text(m_cryptogram,m_cryptogramsize);    
  
    return 0;
}

//=========================================================
void CCoder::print_cryptogram() 
{
   cout<<"CRYPTOGRAM:\n"<<m_cryptogram<<"\n--------\n";
}

void CCoder::print_text() 
{
   cout<<"TEXT:\n"<<m_text<<"\n--------\n";
}

void CCoder::print_key() 
{
   cout<<"KEY:\n"<<m_key<<"\n--------\n";
}

