//////////////////////////////////////////////////////////////////
//  cryptographer server
//
//     FILE : cryptserver.h
//  CREATED : 19.07.2000
// (C) Borisov E.S. Kiev UA
//
//       OS : QNX 4.25
// COMPILER : Watcom C/C++ 10.6
//
/////////////////////////////////////////////////////////////////
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <iostream.h>
#include <errno.h>
#include <unistd.h>
#include <stdio.h>

#include "netparams.h"
#include "cryptserver.h"



//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
CCryptserver::CCryptserver():m_isresult(0){}

//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
CCryptserver::~CCryptserver(){}

//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
void CCryptserver::run(char* lex_file)
{
   cout<<"server : ";
   if( m_iterator.load_gram(lex_file) )return;  
   cout<<"wordlist '"
       <<lex_file<<"' - "
       <<m_iterator.get_lex_quantity()
       <<" words readed\n";

   for(;;)
   {
      if(accept()) return;
      if(check_command())break;
   }   
}

//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
int  CCryptserver::check_command()
{
    int command=0;
    int res=0;
    
    if(recv(&command,sizeof(command))<1)
	{
       disconnect();
	   return 0;
	}

    switch(command)
    {
       case NET_MSG_SHUTDOWN:
         disconnect();
         return 1;

       case NET_MSG_WORK:
         res=receive_work(); 
         disconnect();
         if(!res)work();
         return 0;

       case NET_MSG_RESULT:
         send_result();
         disconnect();
         return 0;

       default:
         disconnect();
         cout<<"server : unknow command #"<<command<<endl;
         return 0;	        
    }
}

//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
void CCryptserver::work()
{
   m_iterator.go();
   m_isresult=1;
}

//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
int CCryptserver::receive_work()
{
   char buf[MAX_BUF]="";
   int  size=0;
   
   char start=0;
   char stop=0;
   int  maxlen=0;
   
   /////////////////////////////////////////////
   // load cryptogram
   if(recv(&size,sizeof(size))<1)
   {
      return 1;
   }

   if(recv(buf,size)<1)
   {
      return 2;
   }
   m_iterator.set_cryptogram(buf,size);  
   //
   /////////////////////////////////////////////

   /////////////////////////////////////////////
   // load key
   if(recv(&start,sizeof(start))<1)
   {
      return 3;
   }
   
   if(recv(&stop,sizeof(stop))<1)
   {
      return 5;
   }

   if(recv(&maxlen,sizeof(maxlen))<1)
   {
      return 6;
   }
   m_iterator.set_params(start,stop,maxlen);
   //
   /////////////////////////////////////////////
   
   return 0;
}

//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
int CCryptserver::send_result()
{
   char szkey[MAX_KEY]="";
   int words=0;
   int size=0;

   if(m_isresult)
   {
       m_iterator.get_maxkey(szkey,MAX_KEY,&words);
       size=sizeof(szkey);
       send(&size,sizeof(size));
       send(szkey,sizeof(szkey));
       send(&words,sizeof(words));

       m_isresult=0;
   }    
   else
   {
       size=0;
       send(&size,sizeof(size));
   }
   return 0;
}
