//////////////////////////////////////////////////////////////////
//  net server
//
//     FILE : tcpserver.cpp
//  CREATED : 08.07.2000
// (C) Borisov E.S. Kiev UA
//
//       OS : QNX 4.25
// COMPILER : Watcom C/C++ 10.6
//
/////////////////////////////////////////////////////////////////
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <iostream.h>
#include <errno.h>
#include <unistd.h>
#include <stdio.h>

#include "tcpserver.h"

//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
CTcpServer::CTcpServer():m_sock(-1),m_msgsock(-1){}

//=========================================================
// FUNCTION : 
// PURPOSE  : 
//
CTcpServer::~CTcpServer(){ close();}

//=========================================================
// FUNCTION : int open(int port)
// PURPOSE  : 
//
int CTcpServer::open(int port)
{
	struct sockaddr_in server;
	int length;

	if(m_sock>-1)close();
	
	cout <<"server : create ........ ";

	///////////////////////////////
	// Create socket 
	if ((m_sock = ::socket(AF_INET, SOCK_STREAM, 0)) < 0) 
	{
		  cerr << "socket - "<<strerror(errno)<<endl;
		  return 1;
	}
	//
	//////////////////////////////////
	
	/////////////////////////////////////
	// Name socket using wildcards 
	server.sin_family = AF_INET;
	server.sin_port = htons(port);
	server.sin_addr.s_addr = INADDR_ANY;
	
	if (::bind(m_sock, (struct sockaddr *)&server, sizeof(server))) 
	{
	    cerr <<"bind - "<< strerror(errno)<<endl;
		return 2;
	}
	//
	///////////////////////////////////////////////////
	
	//////////////////////////////////////////////////////
	// Find out assigned port number and print it out 
	length = sizeof(server);
	if( ::getsockname(m_sock, (struct sockaddr *)&server, &length)<0) 
	{
  	    cerr <<"getsockname - "<<strerror(errno)<<endl;
		return 3;
	}
	//
	///////////////////////////////////////////////////

	///////////////////////////////////////////////////
	// listen 
	if(::listen(m_sock, 1))
	{
		cerr << "listen - "<<strerror(errno)<<endl;
		return 4;
	}
	//
	////////////////////////////////////////////
	cout << "ok  (port #" << ntohs(server.sin_port) <<")\n";

	return 0;
}

//=========================================================
// FUNCTION : int accept()
// PURPOSE  : 
//
int CTcpServer::accept()
{
   if(m_msgsock>-1)disconnect();
   
   cout << "server : accept ........ ";
   if ((m_msgsock = ::accept(m_sock, 0, 0)) <0) 
   {
 	  cerr <<strerror(errno)<<endl;
  	  return 1;
   } 
   cout << "ok\n";
   return 0;
}

//=========================================================
// FUNCTION : int recv(void* buffer,int size)
// PURPOSE  : 
//
int CTcpServer::recv(void* buffer,int size)
{
	int rd=-1;
	if((rd=::recv(m_msgsock,buffer,size,0))<1)
	{
  	    cerr <<"server : recv .... "<<strerror(errno)<<endl;
	}
	return rd;
}

//=========================================================
// FUNCTION : int send(void* buffer,int size)
// PURPOSE  : 
//
int CTcpServer::send(void* buffer,int size)
{
   int wr=-1;
   
   if((wr = ::send(m_msgsock,buffer,size,0)) <1)
   {
	    cerr <<"server : send .... "<< strerror(errno)<<endl;
   }
   return wr;
}

//=========================================================
// FUNCTION : int disconnect()
// PURPOSE  : 
//
int CTcpServer::disconnect()
{
    int res=0;
    
    cout << "server : disconnect .... ";
	if(m_msgsock>-1)
	{
		if(::shutdown(m_msgsock,2))		
		{
		   cerr << "shutdown - "<<strerror(errno)<<endl;
		   res++;  
		}

	    if(::close(m_msgsock))
	    {
		   cerr << "close - "<<strerror(errno)<<endl;
		   res++;  
		}
	}
	if(!res)cout << "ok\n";
	m_msgsock =-1;
	
	return res;
}

//=========================================================
// FUNCTION : int close()
// PURPOSE  : 
//
int CTcpServer::close()
{
    int res=0;

	if(m_msgsock>-1)disconnect();
    
    cout << "server : close ......... ";
	if(m_sock>-1)
    {
   	    if( ::shutdown(m_sock,2) )
		{
		   cerr << "shutdown - "<<strerror(errno)<<endl;
		   res++;  
		}

		if( ::close(m_sock) )
		{
		   cerr << "close - "<<strerror(errno)<<endl;
		   res++;  
		}
	}	
	if(!res)cout << "ok\n";
	m_sock =-1;
	
	return res;
}

